#!/bin/awk -f
# deltime.awk returns '<incr_day_flag>:HH:MM:SS.FFFF'
# parameters - ${evhour} ${evmin} ${evsec} ${delop} ${delmin} ${delsec}
BEGIN {
  incr_day_flag="+0";
}
{
  evhour = $1;
  evmin = $2;
  evsec = $3;
  delop = $4;
  delmin = $5;
  delsec = $6;
  evsec = evsec + (delop * delsec);
  while(evsec >= 60){
    evmin++;
    evsec -= 60;
  }
  while(evsec < 0){
    evmin--;
    evsec += 60;
  }
  evmin = evmin + (delop * delmin);
  while(evmin >= 60){
    evhour++;
    evmin -= 60;
  }
  while(evmin < 0){
    evhour--;
    evmin += 60;
  }
  if(evhour < 0){
    incr_day_flag = "-1";
    evhour += 24;
  }
  if(evhour >= 24){
    incr_day_flag = "+1";
    evhour -= 24;
  }
  printf("%s:%02d:%02d:%07.4f",incr_day_flag,evhour,evmin,evsec);
}
