#!/usr/local/bin/perl
#
# gen_event_list.pl <start_YYYY/MM/DD> <end_YYYY/MM/DD> [new]
#     (if YYYY is only YY, then calculate YYYY)
#
# modified by Robert Casey - 8/31/99 adding capability to generate listings
# using new FARM 861 filename pattern -- triggered by using the 'new' flag
#

if (scalar(@ARGV) < 2) {
  open (PIPE, "date +%Y/%m/%d |");
  while (<PIPE>) {
    @e_date_str = split(/[\/\n]/,$_);
  }
  close (PIPE);
  open (PIPE, "date_calc -cc $e_date_str[1]/$e_date_str[2]/$e_date_str[0] -90 |");
  while (<PIPE>) {
    @s_date_str = split(/[\/\n]/,$_);
  }
  close (PIPE);
  $temp = $s_date_str[2];    # reorder m/d/y to y/m/d
  $s_date_str[2] = $s_date_str[1];
  $s_date_str[1] = $s_date_str[0];
  $s_date_str[0] = $temp;
} else {
  @s_date_str = split(/[\/\n]/,$ARGV[0]);
  @e_date_str = split(/[\/\n]/,$ARGV[1]);
}

if (scalar(@ARGV) > 2 && $ARGV[2] eq "new") {
  $new = 1;
}

$FARM_DIR = "/wave/ftp/pub/farm";
$prev_seed_path = "";

chdir "/wave/ftp/pub/weed/farm_events";

if ($s_date_str[0] < 1900) {$s_date_str[0] += 1900;}
if ($s_date_str[0] < 1950) {$s_date_str[0] += 100;}
if ($e_date_str[0] < 1900) {$e_date_str[0] += 1900;}
if ($e_date_str[0] < 1950) {$e_date_str[0] += 100;}

open (PIPE, "ls *.events |");
$count = 0;
@event_files = (" "," ");
while (<PIPE>) {
  $event_files[$count] = $_;
  chop($event_files[$count]);
  $count++;
}
close (PIPE);

for ($i=0;$i<$count;$i++) {
  ($event_year) = ($event_files[$i] =~ /([0-9][0-9][0-9][0-9])\.events/);
  if ($event_year < $s_date_str[0] || $event_year > $e_date_str[0]) {next;}
  open (EVENTS, "cat $event_files[$i] | sort -t, +1 -2 |");
  EVENT_LOOP: while (<EVENTS>) {
    @event_line = split(/, /,$_);  # yes that is really comma+space
    @date_line = split(/[\/ :]/,$event_line[1]);
    $line_combine = "$date_line[0]$date_line[1]$date_line[2]";
    $s_combine = "$s_date_str[0]$s_date_str[1]$s_date_str[2]";
    $e_combine = "$e_date_str[0]$e_date_str[1]$e_date_str[2]";
    if ($line_combine < $s_combine) {next EVENT_LOOP;}
    if ($line_combine > $e_combine) {next EVENT_LOOP;}

    open (PIPE,"/www/HTML/wilber_dir/bin/get_region $event_line[2] $event_line[3] |");
    while (<PIPE>) {
      @fe_arr = split(/[\n ]/,$_);
      shift(@fe_arr);
      $fe_string = join('_',@fe_arr);
    }
    close (PIPE);

    # event data source
    @month = ("-","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
      $ev_str = sprintf("%s%s%s_%s%s",substr($date_line[0],2,2),$date_line[1],$date_line[2],$date_line[3],$date_line[4]); 
    if ($new) {
      $new_ev_str = sprintf("%s%s%s_%s%s%s",$date_line[0],$date_line[1],$date_line[2],$date_line[3],$date_line[4],$date_line[5]);
    }
    if ($event_line[0] eq "spyder") {
      $ev_source = "SPYDER";
      if ($new) {
        $seed_path = sprintf("%s/%s/%s/%s.spyder.seed",$date_line[0],$month[$date_line[1]],$ev_str,$new_ev_str);
      } else {
        $seed_path = sprintf("%s/%s/%s/%s.spyder.seed",$date_line[0],$month[$date_line[1]],$ev_str,$ev_str);
      }
    } else {
      $ev_source = "FARM";
      if ($new) {
        $seed_path = sprintf("%s/%s/%s/%s.gsn.seed",$date_line[0],$month[$date_line[1]],$ev_str,$new_ev_str);
      } else {
        $seed_path = sprintf("%s/%s/%s/%s.seed",$date_line[0],$month[$date_line[1]],$ev_str,$ev_str);
      }
    }

    # verify that the seed file is actually present, otherwise don't list
    if (! -e "${FARM_DIR}/${seed_path}") {next;}

    # verify that this isn't a redundant listing of the same event
    if (${prev_seed_path} eq ${seed_path}) {next;}
    $prev_seed_path = $seed_path;

    # latitude
    if ($event_line[2] > 60.0) {$row = 1;} 
    elsif ($event_line[2] > 0.0) {$row = 2;}
    elsif ($event_line[2] > -60.0) {$row = 3;} 
    else {$row = 4;}

    # longitude
    if ($event_line[3] < -120.0) {$col = "A";}
    elsif ($event_line[3] < -60.0) {$col = "B";}
    elsif ($event_line[3] < 0.0) {$col = "C";}
    elsif ($event_line[3] < 60.0) {$col = "D";}
    elsif ($event_line[3] < 120.0) {$col = "E";}
    else {$col = "F";}
    
    $map_grid = "${col}${row}";

    # magnitude field sometimes get a \n in it
    @mag = split(/[\n ]/,$event_line[8]);

    print "$event_line[1] - $event_line[2] $event_line[3] $mag[0] $event_line[4] ${fe_string} ${ev_source} ${map_grid} ${seed_path}\n";
  }
  close (EVENTS);
}
exit (0);
