#!/usr/local/bin/perl

# John Castle (castle@geophys.washington.edu)
# August, 1998
# This program was created to watch over wilber and elminate problems
# when jobs hang in the que

$time_limit = 15; # set time limit for files in que (minutes)
$nowtime = time();
$number_of_files = 0;

chdir("/www/HTML/tmp/") # chdir to wilber que directory
 	|| die "Cannot cd to /www/HTML/tmp/: ($!)"; 
while ( defined ($filename = glob("*.wque.*")) ) {
	open (QUELIST, $filename) # find the file names
		|| die "can't open quelist: $!";
	$time = -M QUELIST; # how old are the files?
	$time = $time * 24 *60;  # time in minutes
	$times{$filename} = $time;  # make hash table of filename and time	
	++$number_of_files;
	close(QUELIST) || warn "couldn't close quelist: $!";
}

if ($number_of_files > 0) {  # If some que files exist
	@timelist = sort {$times{$a} <=> $times{$b}} keys(%times); 	$longest_file = $timelist[-1];              # filename
	$longest_time = $times{$longest_file};      # longest time
	$long_time = sprintf("%4.1f",$longest_time); # formatted longest time 

#	foreach (@timelist) {print "$_ has a time of $times{$_}\n";}
#	print "$longest_file is longest with a time of $long_time minutes\n";

	if ($longest_time > $time_limit) { # is the time too long?
		@names = split(/\./,$longest_file); # seperate off the ending
		$user_name = $names[0]; # we'll use this to find the directory
		$user_ftp_dir = "/wave/ftp/pub/userdata/".$user_name;
		$pid = $names[-1]; # we'll use this to find the directory
		$directory = glob("wilber.$pid");
		$param_file = $directory."/wilber.params";
		$sum_file   = $directory."/wilber.summary";
		$sta_file   = $directory."/wilber.sta_lat_lon";
		
		open(PARAM_FILE,$param_file) ||
			warn "cannot open $param_file for reading: ";
		open(SUM_FILE,$sum_file);
		open(STA_FILE,$sta_file);

		open (MAIL,"|mail castle\@iris.washington.edu debbie\@iris.washington.edu rob\@iris.washington.edu badger\@iris.washington.edu");
		print MAIL "This mail was generated by program wilber_watch_que (John Castle).\n";
		print MAIL "It detected a file in the wilber que over $time_limit minutes old.\n\n";
		print MAIL "Filename $longest_file was too old, $long_time minutes, and was deleted.\n\n";
		print MAIL "The current que includes (sorted by increasing age) : \n";
		foreach (@timelist) {
			write (MAIL);
		}
		
		print MAIL "\nThe parameter file contents were : \n";
		print MAIL "($param_file) \n";
		print MAIL "=============================\n\n";
		while (<PARAM_FILE>) {
			print MAIL $_;
		}

		print MAIL "\n=============================";
		print MAIL "\nThe station file contents were : \n";
		print MAIL "($sta_file) \n";
		print MAIL "=============================\n\n";
		while (<STA_FILE>) {
			print MAIL $_;
		}

		print MAIL "\n=============================";
		print MAIL "\nThe summary file contents were : \n";
		print MAIL "($sum_file) \n";
		print MAIL "=============================\n\n";
		while (<SUM_FILE>) {
			print MAIL $_;
		}

		close MAIL;
		close PARAM_FILE || warn "couldn't close $param_file";
		close SUM_FILE;
		close STA_FILE;
		
		$ftp_readme = ">".$user_ftp_dir."/README_ERROR_".$pid;
		open (FTP_README, $ftp_readme) # open a README file in their ftp site
			|| warn "cannot open $ftp_readme for writing";
		print FTP_README "Your request, $longest_file, did not work!\n";
		print FTP_README "Please try again later.\n";
		print FTP_README "If the request still fails, contact debbie\@iris.washington.edu\n";
		print FTP_README "Thank you for making use of WILBER!\n";
		close FTP_README || warn "couldn't close $ftp_readme";
		chmod (0666, $user_ftp_dir."/README_ERROR_".$pid) ||
			warn ("couldn't chmod on file ".$user_ftp_dir."/README_ERROR_".$pid);


		$i= $number_of_files;
		foreach (@timelist) {
			$when = $nowtime - $i; # set $when to now minus 1 sec for each file
			++$i; # increase time -- keep the que in order by increasing time back by 1 sec.
			utime($when,$when,$_);  # reset time of the files
		}
		
		unlink ($longest_file);# delete the offending file
		
		$problem_name = "$user_name.Problem.$pid";
		system("touch $problem_name");  # this writes  anote that there was a problem
	    
# notify the user - I've created a new ending to nph-wilber_request.pl which is currently in End1
	}
}

# formats for writing diagnostic files
format MAIL =
@<<<<<<<<<<<<<<<<<<<< @<<<<<<<
$_, $times{$_}
.

format MAIL_TOP =

Quename               Time (min)
===================== =========
.
