BEGIN {
  station_color = "245/0/0"  # SPYDER station color;
  fstation_color = "255/255/0" # FARM station color;
  x = 0;
  prev_mins = 0.0;
  prev_lat = 0.0;
  prev_lon = 0.0;
  prev_date = "0/0/0";
}
/^[0-9]/{
  if ($9 == "SPYDER") {
    color = station_color;
  } else {
    color = fstation_color;
  }

  # detect transition
  split($2,ts,/:/);
  mins = (ts[1] * 60.0) + ts[2] * 1.0 + (ts[3]/60.0);
  delta_mins = mins - prev_mins;
  delta_lat = ($4 * 1.0) - prev_lat;
  delta_lon = ($5 * 1.0) - prev_lon;
  if ( ! ($1==prev_date && delta_mins >= -2.0 && delta_mins <= 2.0 && delta_lat >= -2.0 && delta_lat <= 2.0 && delta_lon >= -2.0 && delta_lon <= 2.0) ) {
    # transition from one group to the next - indicate this with a CR
    if (x==0) {
      x=1;
    } else {
      printf("\n");
    }
  }
  prev_mins = mins;
  prev_lat = $4;
  prev_lon = $5;
  prev_date = $1;

  # for display purposes, make any latitude values that extend above or below
  # +/-80 degrees equal to +/-80 degrees so it will show on the map
  # Robert Casey -- April 6, 1999
  if ($4 < -80) {
    disp_lat = -80;
  } else if ($4 > 80) {
    disp_lat = 80;
  } else {
    disp_lat = $4;
  }

  #      mag lat lon color
  printf("%s %s %s %s ",$6,disp_lat,$5,color);
}
END {
  printf ("\n");
}
