#!/usr/local/bin/perl
# July 25, 1997
# written by D. Barnes and Rob Casey
# interface for SPYDER/FARM data retrieval - Window 2 - Bottom
# using cgi-lib.pl
#
# modified by Robert Casey 8/30/99 - FARM 861 filename conversion
#

$| = 1;

push(@INC, "/www/apache/apache_1.3.4/cgi-bin/");
require("/www/apache/apache_1.3.4/cgi-bin/cgi-lib.pl");
&ReadParse(*param);

print &PrintHeader;

print "<html>\n";
print "<head>\n";
print "<title>station map</title>\n";
print "</head>\n";

print "<body BGCOLOR=\"#ffffff\">\n";
print "<TABLE BORDER=0 WIDTH=95%><TR><TD ALIGN=LEFT>\n";
print "<strong>FTP-able files for event:</strong>\n";
print "</TD><TD ALIGN=RIGHT>\n";
print "<strong>Map of all stations responding to this event:</strong>\n";
print "</TD></TR></TABLE>\n";

# establish event file and determine if the file exists
if ($param{'core_pid'} >= 100000) {
  $event_file = "/www/HTML/wilber_dir/current_wilber_event.txt";
} else {
  $event_file = "/www/HTML/wilber_dir/events_dir/$param{text_file}";
}

if (! -e "$event_file") {
  print "<br><h2>Unable to find event file...</h2>\n";
  print "</BODY>\n";
  print "</HTML>\n";
  exit (0);
}

print "<TABLE border=1 cellpadding=2 width=95%>\n";
print "<tr>\n";

open (EVFILE,"$event_file");
while (<EVFILE>) {
  @ev_line = split(/[ \n]/,$_);
  if ($ev_line[0] eq $param{'ev_date'} && $ev_line[1] eq $param{'ev_time'} && $ev_line[8] eq $param{'ev_source'}) {
    last;
  }
}
close (EVFILE);

$gif_path = ${ev_line[10]};
$gif_path =~ s/\.seed/.map.gif/g;  # okay, so the pathname of the gif file
                                   # is established

# display list of related files in first table cell
print "<td align=left valign=top>\n";

$farm_dir = $gif_path;
$farm_dir =~ s/\/[0-9][0-9][0-9][0-9][0-9][0-9]*[0-9]_[0-9][0-9]*[0-9][0-9][0-9]\..*map\.gif$//;

@ev_prefix = ($gif_path =~ /^[0-9][0-9][0-9][0-9]\/[A-Z][a-z][a-z]\/[0-9][0-9][0-9][0-9][0-9][0-9]_[0-9][0-9][0-9][0-9]\/([0-9][0-9][0-9][0-9][0-9][0-9]*[0-9]_[0-9][0-9]*[0-9][0-9][0-9]\..*)map\.gif/);
open (PIPE,"ls /wave/ftp/pub/farm/${farm_dir} |");
while (<PIPE>) {
  $eventfile = $_;
  chop ($eventfile);
  foreach $suffix ("stations","seed","ps","gif","bhz.gif","lhz.gif","lhr.gif","lht.gif","vhz.gif","contents","problems","sizes") {
    if ($eventfile =~ /$ev_prefix[0]${suffix}/) {
      print "<a href=\"/pub/farm/${farm_dir}/${eventfile}\">${eventfile}</a><br>\n";
    }
  }
}
close (PIPE);

# display image in second table cell
if (! -e "/wave/ftp/pub/farm/${gif_path}" || ${gif_path} eq "") {
  print "<td><h2>IMAGE MAP UNAVAILABLE</h2>\n";
} else {
  print "<td><IMG SRC=\"/pub/farm/${gif_path}\" ALIGN=\"BOTTOM\">\n";
}

print "</tr>\n";

print "</TABLE>\n";
print "</BODY>\n";
print "</HTML>\n";

