#!/usr/local/bin/perl
# July 2, 1997
# written by D. Barnes and Rob Casey
# interface for SPYDER/FARM data retrieval - Window 2 - Middle
# using cgi-lib.pl
#

$|=1;

push(@INC, "/www/apache/apache_1.3.4/cgi-bin/");
require("/www/apache/apache_1.3.4/cgi-bin/cgi-lib.pl");

&ReadParse(*param);

print &PrintHeader;
print "<HTML>\n";
print "<BODY BGCOLOR=\"ffffff\">\n";

# NOTE: $param{'station'} is of the form STAT.NC

print "<strong>Waveform Plots for Station <font color=cc0000>$param{'station'}</font>";

@event_arr = split(/\//,$param{'file_path'});
$event_year = $event_arr[5];
$event_time = $event_arr[7];
@hyp_event_time = ($event_arr[8] =~ /^([0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]_[0-9][0-9][0-9][0-9][0-9][0-9].[0-9])\..*contents$/);

# check to see if the plot files are already there
# if not, build them
if (-e "/www/HTML/wilber_dir/sac_plots/${event_year}" && $hyp_event_time[0] ne "") {
  $event_time = "${event_year}/$hyp_event_time[0]";  # modify event time to 861 format
}

# this loop allows a list of images to be generated if they exist
# or for the images to be generated followed by another iteration to
# generate the list
$plots_ready = 0;  #initialize
@filename = ();
@channel = ();
while ($plots_ready < 3) {
  $count = 0;
  $plots_ready++;
  open (PIPE, "/bin/ls /www/HTML/wilber_dir/sac_plots/${event_time}_$param{'ev_source'}_$param{'station'}_*.gif |");
  while (<PIPE>) {
    chomp $_;
    $filename[$count] = $_;
    @filearr = split(/[_.]/,$filename[$count]);
    $channel[$count] = $filearr[$#filearr-1];
    $count++;
  }
  close (PIPE);
  if ($count == 0 && $plots_ready < 2) {
    print " -- (building plots...please wait)</strong><p>\n";
    system ("/www/HTML/wilber_dir/bin/gen_sac_plots_silent $param{'ev_source'}\@$param{'file_path'}\@$param{'station'}") == 0 or die "ERROR in building plots -- please notify webmaster<p>\n";
    $plots_ready++;
  } else {
    print "</strong><p>\n";
    $plots_ready = 3;
  }
}

# okay, the plots must be there, so let's display the images
for ($indx=0;$indx < scalar(@filename);$indx++) {
  @filearr = split(/\//,$filename[$indx]);
  $imgsrc = join('/',@filearr[3..$#{filearr}]);
  print "<font color=cc0000><strong>$channel[$indx]</strong></font><br><img src=/$imgsrc vspace=2><p>\n";
}

print "</BODY></HTML>";
exit (0);
