#!/usr/local/bin/perl
# July 28, 1997
# request processing script for WILBER
# written by Rob Casey
# using cgi-lib.pl
#
# Modified Sept 98 by John Castle for SAC ASCII support
#
# Modified Aug 99 by Robert Casey for SAC BINARY support and new refresh scheme

$| = 1;

push(@INC, "/www/apache/apache_1.3.4/cgi-bin/");
require("/www/apache/apache_1.3.4/cgi-bin/cgi-lib.pl");
&ReadParse(*param);

# --- PARAMETERS ---
#core_pid - pass 1
#ev_date - pass 1
#ev_time - pass 1
#ev_source - pass 1
#seed_path - pass 1
#channel - pass 1
#station - pass 1
#before - pass 1
#after - pass 1
#user_name - pass 1
#ev_lat - pass 1
#ev_lon - pass 1
#data_format - pass 1
#pid - pass 2
#queued - pass 2
#user_dir - pass 2
#label - pass 2
#suffix_name - pass 2
#log_suffix - pass 2

# common HTML header
print &PrintHeader;

# start common HTML
print "<html>\n";

if ($param{'channel'} eq "" || $param{'station'} eq "") {
  print "<body BGCOLOR=\"#ffffff\">\n";
  print "<h3>ERROR: You have forgotten to select channels and/or stations.  Please resubmit your request with these selected.</h3>\n";
  print "</body></html>\n";
  exit (0);
}

if (! -e "/wave/ftp/pub/farm/$param{'seed_path'}") {
  print "<body BGCOLOR=\"#ffffff\">\n";
  print "<h3>ERROR: You have forgotten to select channels and/or stations.  Please resubmit your request with these selected.</h3>\n";
  print "<h3>I'm sorry, but the SEED data file for this event is currently offline or unavailable.  Please check back on this event in the future.</h3>\n";
  print "</body></html>\n";
  exit (0);
}

$sleep = 60;  # number of seconds delay between PUSH iterations

# convert channel and station selection lists from POST null separated list
# to comma separated list
$chans = "$param{'channel'}";
$chans =~ s/\0/,/g;
$param{'channel'} = "$chans";
$stats = "$param{'station'}";
$stats =~ s/\0/,/g;
$param{'station'} = "$stats";

# move to tmp processing directory
chdir "/www/HTML/tmp";

########################################
# MAIN RECURSION SWITCH
# IF 'queued' flag is not set, then initialize processing directory, set
# up parameter file, set the process id (pid), set 'queued' flag to 1,
# and refresh forward to queue monitoring loop
# ELSE continue with queue monitoring loop until queue file no longer present
if ($param{'queued'} < 1) {

  # set process id
  $pid = $$;

  # set up user's scratch directory
  system ("mkdir wilber.${pid}; chmod 777 wilber.${pid}");

  # create queue file
  $queue_name = "$param{'user_name'}.wque.${pid}";
  system("touch ${queue_name}");

  # set up userdata directory
  $user_dir = "/pub/userdata/$param{'user_name'}";
  system ("/bin/mkdir -p /wave/ftp${user_dir}; chmod 777 /wave/ftp${user_dir}");

  # set up output file name with a possible sequence number at the end
  @event_arr = split(/\//,$param{'seed_path'});
  if ($param{'ev_source'} eq "SPYDER") {
    $label = "WLBR_SPYD_$event_arr[2]";
  } else {
    $label = "WLBR_FARM_$event_arr[2]";
  }
  $suffix = "";
  open (PIPE,"/bin/ls /wave/ftp${user_dir} |");
  while (<PIPE>) {
    $filename = $_;
    chop ($filename);
    if ($filename eq "${label}${suffix}.seed") {
      if ("${suffix}" eq "") {
        $suffix = 0;
        $label = "${label}_";
      }
      $suffix++;
      $suffix = sprintf("%04d",$suffix);
    }
  }
  close (PIPE);

  # figure out output file name suffixes
  $log_suffix = $suffix . ".log";
  $suffix = $suffix . ".seed";
  $data_form = $param{'data_format'};
  $suffix_name = $suffix;
  $suffix_name =~ s/seed/$data_form/;
  # REC
  # for binary SAC, the suffix is still like ascii, chop off 'bin'
  # from suffix_name but preserve in data_form
  #
  if ($data_form =~ /^bin.SAC/) {
    $suffix_name =~ s/bin.SAC/SAC/;
  }

  # mark this request as having been queued
  $param{'queued'} = 1;

  # now that we have enough synthesized information...
  # print HTML to notify user of initialization -- short duration refresh
  print "<HEAD>\n";
  print "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5;URL=/cgi-bin/wilber_request.pl?";
  print "core_pid=$param{'core_pid'}&";
  print "ev_date=$param{'ev_date'}&";
  #
  $ord_ev_time = $param{'ev_time'};
  $ord_ev_time =~ s/(\W)/sprintf("%%%x",ord($1))/eg; # convert non-letter characters to ordinal for safe GET passage
  print "ev_time=${ord_ev_time}&";
  #
  $ord_ev_source = $param{'ev_source'}; 
  $ord_ev_source =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "ev_source=${ord_ev_source}&";
  #
  $ord_seed_path = $param{'seed_path'};
  $ord_seed_path =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "seed_path=${ord_seed_path}&";
  #
  print "channel=$param{'channel'}&"; 
  print "station=$param{'station'}&";
  print "before=$param{'before'}&";
  print "after=$param{'after'}&";
  #
  $ord_user_name = $param{'user_name'};
  $ord_user_name =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "user_name=${ord_user_name}&";
  #
  $ord_ev_lat = $param{'ev_lat'};
  $ord_ev_lat =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "ev_lat=${ord_ev_lat}&";
  #
  $ord_ev_lon = $param{'ev_lon'};
  $ord_ev_lon =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "ev_lon=${ord_ev_lon}&";
  #
  $ord_data_format = $param{'data_format'};
  $ord_data_format =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "data_format=${ord_data_format}&";
  #
  print "pid=${pid}&";
  print "queued=$param{'queued'}&";
  #
  $ord_user_dir = $user_dir;
  $ord_user_dir =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "user_dir=${ord_user_dir}&";
  #
  $ord_label = $label;
  $ord_label =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "label=${ord_label}&";
  #
  $ord_suffix_name = $suffix_name;
  $ord_suffix_name =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "suffix_name=${ord_suffix_name}&";
  #
  $ord_log_suffix = $log_suffix;
  $ord_log_suffix =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  print "log_suffix=${ord_log_suffix}"; 
  #
  print "\">\n";
  print "</HEAD>\n";
  print "<BODY BGCOLOR=\"#ffffff\">\n";
  print "<h1><center> - Please Wait -</center></h1>\n";
  print "<p><center><b>Your request is being queued into WILBER processing</b></center><br>\n";

  # touch output file
  system "touch /wave/ftp${user_dir}/${label}${suffix_name}";

  # create parameter file
  chdir "/www/HTML/tmp/wilber.${pid}";
  open (PFILE,">wilber.params");
  print PFILE "$queue_name\n";                             # queue_name
  print PFILE "/wave/ftp/pub/farm/$param{'seed_path'}\n";  # path to FARM SEED
  print PFILE "/wave/ftp${user_dir}/${label}${suffix}\n";  # product name
  print PFILE "$param{'channel'}\n";                                  # channels
  print PFILE "$param{'station'}\n";                                  # stations
  print PFILE "$param{'before'}\n";                        # before P
  print PFILE "$param{'after'}\n";                         # after P
  print PFILE "$param{'ev_lat'}\n";			     # event lat
  print PFILE "$param{'ev_lon'}\n";			     # event lon
  print PFILE "$ENV{'REMOTE_HOST'}\n";		     # remote host
  print PFILE "$param{'data_format'}\n";           # data format
  close (PFILE);

  # instead of the invocation below, a cron job (as user 'www')
  # will pick up the next file
  # in the queue and invoke wilber_rdseed
  #### call script to start background rdseed session
  ####exec "/www/apache/apache_1.3.4/cgi-bin/wilber_rdseed &";

  # we are done for pass 1

####################################

# continue monitoring the queue until queue file is no longer present
} else {

  # regenerate expected queue file name
  $queue_name = "$param{'user_name'}.wque.$param{'pid'}";
  # get position in the queue
  $count = 0;
  open (PIPE,"ls -tr *.wque.* |");
  while (<PIPE>) {
    $count++;
    $fil = $_;
    chop($fil);
    if ($fil eq $queue_name) {last;}
  }
######## if processing has finished, then cycle to print final message
######## set queued flag to 2 to signal last pass
  if ($fil ne $queue_name || $count == 0) {
    $param{'queued'} = 2;
  }
  close (PIPE);

  if ($param{'queued'} < 2) {
    # print HTML refresh page to update processing status
    print "<HEAD>\n";
    print "<META HTTP-EQUIV=\"refresh\" CONTENT=\"${sleep};URL=/cgi-bin/wilber_request.pl?";
    print "core_pid=$param{'core_pid'}&";
    print "ev_date=$param{'ev_date'}&";
    #
    $ord_ev_time = $param{'ev_time'};
    $ord_ev_time =~ s/(\W)/sprintf("%%%x",ord($1))/eg; # convert non-letter characters to ordinal for safe GET passage
    print "ev_time=${ord_ev_time}&";
    #
    $ord_ev_source = $param{'ev_source'}; 
    $ord_ev_source =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "ev_source=${ord_ev_source}&";
    #
    $ord_seed_path = $param{'seed_path'};
    $ord_seed_path =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "seed_path=${ord_seed_path}&";
    #
    print "channel=$param{'channel'}&"; 
    print "station=$param{'station'}&";
    print "before=$param{'before'}&";
    print "after=$param{'after'}&";
    #
    $ord_user_name = $param{'user_name'};
    $ord_user_name =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "user_name=${ord_user_name}&";
    #
    $ord_ev_lat = $param{'ev_lat'};
    $ord_ev_lat =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "ev_lat=${ord_ev_lat}&";
    #
    $ord_ev_lon = $param{'ev_lon'};
    $ord_ev_lon =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "ev_lon=${ord_ev_lon}&";
    #
    $ord_data_format = $param{'data_format'};
    $ord_data_format =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "data_format=${ord_data_format}&";
    #
    print "pid=$param{'pid'}&";
    print "queued=$param{'queued'}&";
    #
    $ord_user_dir = $param{'user_dir'};
    $ord_user_dir =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "user_dir=${ord_user_dir}&";
    #
    $ord_label = $param{'label'};
    $ord_label =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "label=${ord_label}&";
    #
    $ord_suffix_name = $param{'suffix_name'};
    $ord_suffix_name =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "suffix_name=${ord_suffix_name}&";
    #
    $ord_log_suffix = $param{'log_suffix'};
    $ord_log_suffix =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
    print "log_suffix=${ord_log_suffix}"; 
    #
    print "\">\n";
    print "</HEAD>\n";
    print "<BODY BGCOLOR=\"#ffffff\">\n";

    print "<h3>Request being processed for: </h3>\n";
    print "Seed file: <b>/pub/farm/$param{'seed_path'}</b><br>\n";
    print "channels selected: <b>";
    print "$param{'channel'}<br>\n";
    print "</b>stations selected: <b>";
    print "$param{'station'}<br>\n";
    print "</b>time window: <b>$param{'before'}</b> minutes before P and <b>$param{'after'}</b> after P<p>\n";
    print "Your request has been queued as <b>${queue_name}</b> and is number <font color=cc0000><b>${count}</b></font> in the queue.<br>\n";

    print "The product will be accessible through ftp in directory <b>$param{'user_dir'}</b> and\n";
    if ($param{'suffix_name'} =~ /SAC.ind/){
      print "will consist of several SAC files.\n";
    }
    else {
      print "will be named <a href=\"$param{'user_dir'}/$param{'label'}$param{'suffix_name'}\">$param{'label'}$param{'suffix_name'}</a>.\n";
    }
    print " <i>(Note: allow time for the file to be completed)</i><br>\n";

    print "<br>This page will update itself every <b>${sleep}</b> seconds until request data has been completed.  Resume browsing activity to stop the link.  Note that this will not halt the processing of your request.</br>\n";

    print "<p>If you selected SEED data format, the data product you will download will be in SEED format. If you are unfamiliar with this format you should download the <a href=\"/HTM/manuals.htm\" target=\"_blank\">SEED manual</a> (in <a href=\"/manuals/whatpdf.html\" target=\"_blank\">.PDF</a> format). You will also need to <a href=\"/manuals/rdseed.html\"  target=\"_blank\">download rdseed</a> - a UNIX application for reading SEED volumes.\n";

# we are done with pass 2, continue until queued == 2

#######################################

  } else { # queued == 2
           # processing finished -- notify the user

    # common HTML header
    print "<BODY BGCOLOR=\"#ffffff\">\n";

    $Problem_filename = $param{'user_name'} . ".Problem." . $param{'pid'};

    if (-e $Problem_filename || -e "/www/HTML/tmp/wilber.${pid}/wilber.err") {
	print "<h3>Request ${queue_name}  <font color=cc0000><b>did not</b></font> process correctly.</h3>\n";
	print "Please try again later.\n";
	print "If the request still fails, contact <a href=\"mailto:debbie\@iris.washington.edu\">debbie\@iris.washington.edu</a>.<p>\n";
	print "Thank you for making use of <b>WILBER</b>!\n";
    } else {
	print "<h3>Request ${queue_name} is finished!</h3>\n";
	print "You can access your data through FTP to dmc.iris.washington.edu.\n";
	if ($param{'data_format'} eq "SAC.ind"){
          print "The seismograms consist of several SAC files (with SAC_ASC suffix) in the ftp site <a href=\"$param{'user_dir'}/\">http://www.iris.washington.edu$param{'user_dir'}</a>.<br>\n";
	} elsif ($param{'data_format'} eq "bin.SAC.ind") {## REC --- SAC binary
          print "The seismograms consist of several binary SAC files (SAC suffix) in the ftp site <a href=\"$param{'user_dir'}/\">http://www.iris.washington.edu$param{'user_dir'}</a>.<br>\n";
        } else {
          print "The filename is <a href=\"$param{'user_dir'}/$param{'label'}$param{'suffix_name'}\">$param{'user_dir'}/$param{'label'}$param{'suffix_name'}</a>.<br>\n";
	}
	print "If you find that the file has no data or something is amiss, review the log file <a href=\"$param{'user_dir'}/$param{'label'}$param{'log_suffix'}\">$param{'user_dir'}/$param{'label'}$param{'log_suffix'}</a> to verify what was written.<p>\n";
	print "If you have any questions or concerns, feel free to contact <a href=\"mailto:debbie\@iris.washington.edu\">debbie\@iris.washington.edu</a>.<p>\n";
	print "Thank you for making use of <b>WILBER</b>!\n";
    } # end IF Problem_filename

  } # end IF queued < 2

}  # end main IF branch

# print closing HTML
print "</body></html>\n";

# exit gracefully
exit (0);
