#!/usr/local/bin/perl
# Written by D Barnes and Robert Casey -- IRIS DMC
# using cgi-lib.pl
$|=1;

push(@INC,"/www/apache/apache_1.3.4/cgi-bin/");
require("/www/apache/apache_1.3.4/cgi-bin/cgi-lib.pl");

&ReadParse(*param);

print &PrintHeader;
print "<HTML><HEAD><BASE TARGET=\"blank\"></HEAD>\n";
print "<BODY BGCOLOR=\"#ffffff\">\n";
#print "x coordinate = $param{'xy-coordinates.x'}<br>";
#print "y coordinate = $param{'xy-coordinates.y'}<br>";

if ($param{'xy-coordinates.x'} < 34)  {
  $grid_col = "Z";
} elsif ($param{'xy-coordinates.x'} < 116) {
  $grid_col = "A";
} elsif ($param{'xy-coordinates.x'} < 198) {
  $grid_col = "B";
} elsif ($param{'xy-coordinates.x'} < 280) {
  $grid_col = "C";
} elsif ($param{'xy-coordinates.x'} < 362) {
  $grid_col = "D";
} elsif ($param{'xy-coordinates.x'} < 444) {
  $grid_col = "E";
} elsif ($param{'xy-coordinates.x'} < 526) {
  $grid_col = "F";
} else {
  $grid_col = "Z";
}

if ($param{'xy-coordinates.y'} < 22)  {
  $grid_row = "0";
} elsif ($param{'xy-coordinates.y'} < 109) {
  $grid_row = "1";
} elsif ($param{'xy-coordinates.y'} < 212) {
  $grid_row = "2";
} elsif ($param{'xy-coordinates.y'} < 315) {
  $grid_row = "3";
} elsif ($param{'xy-coordinates.y'} < 403) {
  $grid_row = "4";
} else {
  $grid_row = "0";
}

#print "x coordinate = $param{'xy-coordinates.x'}<br>";
#print "y coordinate = $param{'xy-coordinates.y'}<br>";
if ($param{'all'} eq "SHOW ALL") {
  print "<strong>All Events for this Time Period: </strong>\n";
} else {
  print "<strong>Events in Selected Location: </strong>\n";
}
$grid_coord = "${grid_col}${grid_row}";
$core_pid = $param{'core_pid'};
$listfile = $param{'text_file'};

print("<pre>\n");
print("<u><b>DATE       TIME        SOURCE MAG  LAT     LON     DEPTH DESCRIPTION</b></u>\n");

if (${core_pid} >= 100000) {
  open (LISTFILE,"/www/HTML/wilber_dir/current_wilber_event.txt");
} else {
  open (LISTFILE,"/www/HTML/wilber_dir/events_dir/${listfile}");
}

# set up font color cycling - see below
@colorwheel = ("000000","cc0000");
$color_sel = 3;

$prev_lat = 999.0;
$prev_lon = 999.0;
$prev_mins = 0.0;
$count = 0;
$group_count = 0;
@output_line = (" ");
while (<LISTFILE>) {
  @ev = split(/\s/);
  if ($ev[9] eq $grid_coord || $param{'all'} eq "SHOW ALL") {
    $ev_source = $ev[8];
    $ev[5] = sprintf("%3.1f",$ev[5]);
    $ev[3] = sprintf("%6.2f",$ev[3]);
    $ev[4] = sprintf("%7.2f",$ev[4]);
    $ev[6] = sprintf("%7.2f",$ev[6]);
    $ev[7] =~ tr/_/ /;
    if ($ev[8] eq "SPYDER") {
      $ev[8] = "SPYDER&reg";
    } else {
      $ev[8] = sprintf("%7.7s",$ev[8]);
    }
    $lat = $ev[3];
    $lon = $ev[4];
    $time = $ev[1];
    $time =~ s/(\W)/sprintf("%%%x",ord($1))/eg;

# alternate colors between Black and Red
# use same color to group events within 2 minutes and 2 degrees of each other

    @ts = split(/:/,$ev[1]);
    $mins = ($ts[0] * 60.0) + ($ts[1]*1.0) + ($ts[2]/60.0);
    $delta_mins = $mins - $prev_mins;
    $delta_lat =  $lat - $prev_lat;
    $delta_lon =  $lon - $prev_lon;
    $prev_mins = $mins;
    $prev_lat = $lat;
    $prev_lon = $lon;


    ####print "<b>$ev[0] $ev[1] $ev[8] $ev[5] $ev[3] $ev[4] $ev[6] $ev[7]</b>\n";


    # detect group transition - toggle color and initiate printing
    if ( ! ($ev_date eq $prev_date && $delta_mins >= -2.0 && $delta_mins <= 2.0 && $delta_lat >= -2.0 && $delta_lat <= 2.0 && $delta_lon >= -2.0 && $delta_lon <= 2.0) ) {
      $color_sel++;
      if ($color_sel > 1) {$color_sel = 0;}
      $count++;  # this is the total hypocenter (event) count

      #print event selection line(s) - output in source-sorted order
      for ($i=0;$i<$group_count;$i++) {
        @sorted_keys = sort keys %source_index;
      }
      foreach $source (@sorted_keys) {
        print "<font color=$colorwheel[$color_sel]>";
        print "$output_line[$source_index{$source}]";
        print "</font>\n";
      }

      # grab current line into array
      $group_count = 0;
      $output_line[$group_count] = "<a href=\"/cgi-bin/wilber.2.pl?core_pid=${core_pid}&ev_date=$ev[0]&ev_time=${time}&ev_source=${ev_source}&user_name=$param{'user_name'}&text_file=$param{'text_file'}\">$ev[0] $ev[1]</a> $ev[8] $ev[5] $ev[3] $ev[4] $ev[6] $ev[7]";
      %source_index = ("${ev_source}${group_count}","$group_count");
      $group_count++;
    } else {
      # add current line to array
      $output_line[$group_count] = "<a href=\"/cgi-bin/wilber.2.pl?core_pid=${core_pid}&ev_date=$ev[0]&ev_time=${time}&ev_source=${ev_source}&user_name=$param{'user_name'}&text_file=$param{'text_file'}\">$ev[0] $ev[1]</a> $ev[8] $ev[5] $ev[3] $ev[4] $ev[6] $ev[7]";
      $source_index{"${ev_source}${group_count}"} = $group_count;
      $group_count++;
    }
  }
} # end of while loop

# probably one last group to print
if ($group_count) {
  $color_sel++;
  if ($color_sel > 1) {$color_sel = 0;}
  #print event selection line(s) - output in source-sorted order
  for ($i=0;$i<$group_count;$i++) {
    @sorted_keys = sort keys %source_index;
  }
  foreach $source (@sorted_keys) {
    print "<font color=$colorwheel[$color_sel]>";
    print "$output_line[$source_index{$source}]";
    print "</font>\n";
  }
}

print "Total of <b>$count</b> events\n";
print "</pre>\n";
close (LISTFILE);
print "</BODY></HTML>";
exit (0);
